
--Regeln zum Matching zwischen MoveOn Name zu SuperX/CO Name/Matrikelnr (Protokoll Besprechung Fr. Sommer, Hr. Brüggemann und DQ 20.10.2017):

--1. Wenn über Vorname/Nachname/Geburtsdatum eine Matrikelnummer in CO gefunden wird, 
--   wird diese mit höchster Priorität genommen
--2. Wenn über Vorname/Nachname/Geburtsdatum mehrere Matrikelnummern in CO gefunden werden, 
--   wird diejenige aus dem (zeitlich gesehen) letzten Studiengang mit höchster Priorität genommen
--3. Wenn nach obigen Regeln eine Matrikelnr. in CO nicht gefunden werden kann, 
--   es aber in MoveOn eine Matrikelnr. gibt, wird zunächst geprüft ob in MoveOn das gleiche Geburtsdatum gespeichert ist
--   wie in CO. Wenn ja, wird die Matrikelnr. von MoveOn übernommen

delete from mobility_person
where id in (select id from mobility_person_neu);



insert into mobility_person(first_name,
       surname,
       date_of_birth,
       matriculation_id,
       id)
 SELECT first_name,
       surname,
       date_of_birth,
       case when length(matriculation_id) < 11 then val(matriculation_id)
       else null::integer end as matriculation_id,
       id
FROM mobility_person_neu 
 ;


--dann matrikelnr zuweisen:
--Regel 1+2:
update mobility_person set matrikel_nr =(
select max(S.matrikel_nr)
from sos_sos S, sos_stud_d D
where S.matrikel_nr=D.matrikel_nr
and D.nachname=mobility_person.surname
and D.vorname=mobility_person.first_name
and S.d_geburt=mobility_person.date_of_birth
and today() between S.gueltig_von and S.gueltig_bis
)
where matrikel_nr is null
and date_of_birth is not null;

--Regel 3:
update mobility_person set matrikel_nr =matriculation_id
where matrikel_nr is null
and matriculation_id is not null
-- and 0< (select count(*) 
-- from sos_sos S, sos_stud_d D
-- where S.matrikel_nr=D.matrikel_nr
-- and S.matrikel_nr=mobility_person.matriculation_id
-- and S.d_geburt=mobility_person.date_of_birth
-- and today() between S.gueltig_von and S.gueltig_bis
-- )
;


select 'Alle',count(*) from mobility_person
union select 'Mit Matrikelnr.',count(*) from mobility_person
where matrikel_nr is not null;

